library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

library UNISIM;
use UNISIM.VComponents.all;

entity ram_2k is
    Port ( clk : in  STD_LOGIC;
           rst : in  STD_LOGIC;
           cs : in  STD_LOGIC;
           rw : in  STD_LOGIC;
           addr : in  STD_LOGIC_VECTOR (9 downto 0);
           data_in : in  STD_LOGIC_VECTOR (7 downto 0);
           data_out : out  STD_LOGIC_VECTOR (7 downto 0));
end ram_2k;

architecture Behavioral of ram_2k is
	signal we: 			STD_LOGIC;
	signal myaddr: 	STD_LOGIC_VECTOR(10 downto 0);
begin
	ram: component RAMB16_S9
		port map (
			do => data_out,
			addr => myaddr,
			clk => clk,
			di => data_in,
			dip => "0",
			en => cs,
			ssr => '0',
			we => we
		);

	myaddr(9 downto 0)<=addr;
	myaddr(10)<='0';
	we <= cs and (not rw);
end Behavioral;

